local playerClass = select(2, UnitClass("player"))
if not (playerClass == "WARRIOR") then return end
local addon = Broker_Vigilance
local addonName = "Broker_Vigilance"
local addon = CreateFrame('Frame', addonName..'DropDown', UIParent, 'UIDropDownMenuTemplate')
local spellname, _, icon, _, _, _, _, _, _ = GetSpellInfo("50720")
local target = ""
local timeLeft = 0
local spellTimer = 0

local L = {}
if(GetLocale() == 'enUS') then
	L.NOTACTIVE = 'Not Active'
else
	L.NOTACTIVE = 'Not Active'
end

local addonBroker = LibStub("LibDataBroker-1.1"):NewDataObject(addonName , {
	label = spellname, 
	type = "data source", 
	icon = icon,
	text = L.NOTACTIVE,
})

local function GetHexColor(color)
	return ("|cff%.2x%.2x%.2x"):format(color.r * 255, color.g * 255, color.b * 255)
end

local ClassColors = {}
for class, color in pairs(RAID_CLASS_COLORS) do
	ClassColors[class] = GetHexColor(RAID_CLASS_COLORS[class])
end

function addon:OnEvent(event)
	if (event == "COMBAT_LOG_EVENT_UNFILTERED" and arg10 == spellname) then
		local eventname, sourcename, destname = arg2, arg4, arg7
		
		if (sourcename == UnitName("player")) then
			if (eventname == "SPELL_CAST_SUCCESS") then
				target = destname
				local expirationTime = select(7, UnitBuff(target, spellname))
				timeLeft = expirationTime
			end

			if (eventname == "SPELL_AURA_REMOVED") then
				target = ""
			end
		
			if (eventname == "SPELL_AURA_REFRESH") then
				target = destname
				local expirationTime = select(7, UnitBuff(target, spellname))
				timeLeft = expirationTime
			end
		end
	end
end

local UPDATE_INTERVAL = 0.5
local nextCheck = 0

function addon:Update(elapsed)
	nextCheck = nextCheck - elapsed
	
   	if (nextCheck > 0) then 
		return 
	end

	if target == "" or GetTime() > timeLeft then
    		addonBroker.text = L.NOTACTIVE
	else
		local _, class = UnitClass(target)
		spellTimer = "|cffffff00["..format("%.0f",-1*(GetTime()-timeLeft)/60).."m".."]|r"
		addonBroker.text = ClassColors[class]..target..'|r'..spellTimer
	end

    	nextCheck = UPDATE_INTERVAL
  		
end

function addonBroker:OnTooltipShow()
	self:AddLine('|cffC79C6EBroker_Vigilance|r')
end

addon:SetScript("OnUpdate", addon.Update)
addon:SetScript("OnEvent", addon.OnEvent)
addon:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
